<script setup>

import { ref, computed, watch, onMounted, onUpdated, onErrorCaptured, onBeforeMount } from "vue";

import Regions from "@/components/Regions.vue";
import SelectSubregion from "@/components/SelectSubregion.vue";
import { useMouse } from '@/use/mouse.js'

const { x, y } = useMouse()

const regions = ["Europe", "Asia", "Oceania", "Africa", "Americas", "Antarctic"]
const region = ref(null)

const countries = ref(null)

async function fetchCountries(region) {
  console.log(`Fetch countries for region ${region}`)
  countries.value = null
  const res = await fetch(`https://restcountries.com/v3.1/region/${region}`)
  countries.value = await res.json()
}

watch(region, fetchCountries)

/* Bonus subregion*/
const subregions = computed(() => countries.value ? new Set(countries.value.map(c => c.subregion)) : [])
const subregion = ref([])

/* ref na element + mounted */
const selectCountires = ref(null)

onBeforeMount(() => {
  console.log("onBeforeMount", selectCountires.value)
})

onMounted(() => {
  console.log("onMounted", typeof selectCountires.value)
  selectCountires.value.focus()
})
onUpdated(() => {
  console.log("onUpdated")
})
onErrorCaptured((error) => {
  console.log("onErrorCaptured", error)
})

function onSelected(event) {
  if (subregion.value.includes(event)) {
    subregion.value = subregion.value.filter(sr => sr != event)
  } else {
    subregion.value.push(event)
  }
}

</script>

<template>
  <div class="container">
    <div class="row">
      <div class="col-12">
        Mouse position is at: {{ x }}, {{ y }}
      </div>
    </div>
    <div class="row">
      
      <div class="col-sm">
        <label for="region">Region: </label>
        <select id="region" v-model="region" ref="selectCountires">
          <option v-for="reg in regions" :value="reg">{{ reg }}</option>
        </select>
      </div>
      
      <!--<Regions  />-->
      <SelectSubregion v-for="(sub, index) in subregions" 
                       :key="sub" 
                       :title="sub"
                       @selected="onSelected">
        {{ sub }}
      </SelectSubregion>
      <!--
      <div v-for="sub in subregions" :key="sub" class="col-sm">
        <input type="checkbox" :id="sub" :value="sub" v-model="subregion">
        <label :for="sub">{{ sub }}</label>
      </div>
      -->
    </div>
    <hr>
    <div v-if="!countries" class="row">
      <div class="col-sm-12">
        Loading ...
      </div>
    </div>
    <div v-else class="row">
      <div class="col-sm-1" v-for="country in countries" :key="country.cca3">
        <img :src="country.flags.svg" :class="`flag ${subregion.includes(country.subregion) ? 'selected' : ''}`">
      </div>
    </div>
  </div>
</template>

<style scoped>
.flag.selected {
  border: 4px solid red;
}
.flag {
  width: 50px;
  height: 40px;
  border: 4px solid black;
  margin: 2px;
}
</style>
